# Message Window Browser

Required Class Files: mwb.class, mwbread.class Notice Tag: "Message Window Browser, (c) 1997, OpenCube Technologies, Registered (Unique Key ID#)"

Information about the applet and its parameters

Required Parameters

Parameter 1 (the "notice" tag) must be included in the applet tag in order for the applet to work. Most of the parameters will default if you fail to define them, at a minimum you must include the notice tag and and a starting text file location tag. Usually the easiest way to customize the applet is to cut and paste the applet tag information used in the sample and modify it to fit your web page.

Defining Colors

This applet uses a simple RGB or Hexadecimal color definition scheme. On most systems (depending on the software being used to choose a color) its easier to define a color using RGB, however since most web pages define colors using a HEX value we have allowed for both methods of color definition. To define a color using RGB use commas to separate the values such as 255,255,255 (White). To define a color using a hexadecimal value use a pound sign ('#') followed by a 6 digit hex value in the rage of 000000 - FFFFFF (e.g. #FFFFFF is equal to the color White).

Color Definition with RGB: To define a color in one of the color parameters using RGB choose a value between 0 - 255 for the red, green, and blue components separated by commas and typed out in the correct r,g,b order. Below is a sample of how a color parameter using RGB should look, the example specifies several different sample colors for the "bgcolor" parameter.

WHITE: <param name="bgcolor" value="255,255,255">
GREEN: <param name="bgcolor" value="0,255,0">
BLACK: <param name="bgcolor" value="0,0,0">
YELLOW: <param name="bgcolor" value="255,255,0">
OFF WHITE: <param name="bgcolor" value="240,239,234">

The best way to choose the exact color you are looking for without having to guess the numbers is to access your systems Color Picker. Color Pickers usually allow you to drag the mouse over a rainbow type color grid to select a color, and show you the appropriate RGB values. In windows the Color Picker is accessible through MS Paint as well as a majority of the popular Imaging and HTML Authoring Software.

Creating the Files

This applet uses simple text files in order to define each message window page, associated attributes, sizing, URL links, colors, pause delay times, etc. Below are links to the four pages used in the example above...

- Home.txt

- Key.txt

- Customize.txt

- Usage.txt

Each line in the text file represents a customizable section of the scrollable message. Text that is longer than the applet width is automatically put in a multi line format and will be multi-line highlighted if an associated URL and highlight color are defined. Each line must be specified with a series of values identifying the size pause, font name, font size, font style, text color, load URL where, URL, and message. Each value must be separated by a vertical bar ("|" AKA: pipe symbol). Below is an example of how a line in the file defining a message should look.

size pause|font name| font size|font style|text color|load URL where|URL|message.

To specify a section of the scroll message using the default values defined using the parameters just use the message text without any pipe symbols (seven in a row then the message) for that line. If defining some properties but not all make shore to includes all the pipe symbols and leave the attributes using the defaults blank (Note: blank spaces between unused pipes, and seven pipes in a row with no characters after them may cause errors). To create a blank space to seperate paragraphs use a regular blank line or seven pipes with a space character at the end.

Size Pause|
Attribute: Automatically Size the Starting Position of the Following Message
Value=0 or 1 or 2: 0 = do nothing, this is the default value, 1 = Identifies a message as the starting message to be automatically sized to fit the applet height, 2 = Identifies the ending message to be sized. To automatically size messages that span multiple description tags, simply set the starting message to 1 and the ending message to 2 with this parameter. For example if you wanted your second and and third lines in the text file to automatically fit the applet height and your fourth line to become visible only after the second line started off the screen you would simply identify the desc2 as a start sizing message by setting "Size Pause|" = 1 and define the third line as the end sizing message with "sizepause|" = 2. To size only one message to fit the applet height only identify that message as a ending message and do not define a starting message (e.g. "sizepause|" = 2, forces the second message to scroll all the way to the top of the applet before line three becomes visible at the bottom of the applet.)

Font Name|
Attribute: Message Line Font Name
value="X", where X is the name of a standard Java Font (Dialog, Helvetica, TimesRoman, Courier, Symbol)

Font Size|
Attribute: Message Line Font Size
value= X, Where x is the size of the font to use for this message.

Font Style|
Attribute: Message Line Font Style
value= 0,1,2, or 3 Where 0 = plain, 1 = bold, 2 = italic, 3 = bold-italic

Text Color|
Attribute: Message Line Text Color
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: BLACK

URL Where|
Attribute: Load Destination URL Link Where? (Frame Targeting)
The "loadwhere" tag specifies where the document specified in the "URL" value should be loaded. The default is "_self". A value equal to the name (case sensitive) of a frame will load the document in that frame. Setting this value to applet forces the document to load within the applet itself
"applet" show in the applet
"_self" show in the current frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Note: When targeting a frame location with the name of the frame make certain that the case and names are typed identically. If the applet cannot find the frame the document will be loaded in a new window.

URL|
Attribute: Destination URL Link
Value = X, Where X is the location of the document to load relative to the location of the HTML document containing the applet (e.g. if the HTML page containing the applet is located at http://www.opencube.com and the document to load is located at http://www.opencube.com/myhtml/mydoc.htm then the URL value would be "myhtml/mydoc.htm").

Message
Attribute: The message to be displayed
Note: Specific messages must be contained on one line, using a line break, and starting long messages on the next lines of the text file will cause those lines to inherit the default values set using the parameters. Messages longer than the width of the applet are automatically put in a multi-line format.

The Animation Transitions

Define custom animation transitions on the first line of each text file using the keyword heading followed by an equal sign (heading=?). The constants are left - down - right - up. If a heading transition is not defined at the top of the text file the next page simply replaces the previous page without a animation effect. A complete heading line should appear as... heading=left without spaces between the words.

The Applet Parameters

The Applet

Parameter 1
Attribute: Copyright notice.
param name="Notice"
value="Message Window Browser, (c) 1997, OpenCube Technologies, Registered (Unique Key ID#)"
Note: This must be included for the applet to work.

Parameter 2
Attribute: Background Color
param name= "bgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: WHITE

Parameter 3
Attribute: Animation Transition Jump Value
param name= "transitionjump"
Value=X, Where X is the distance in screen pixels for each frame to jump during the custom animation transitions between pages
DEFAULT: 2

Parameter 4
Attribute: Default Status Bar Text when mouse is over applet
param name = "onsbtext"
value="X", where X is the message to appear in the status bar when the mouse is over the applet but not over a URL link.
DEFAULT: "Vertical Scrolling Browser"

Parameter 5
Attribute: Default Status Bar Text when mouse is off applet
param name = "offsbtext"
value="X", where X is the message to appear in the status bar when the mouse is not over the applet.
DEFAULT: "Java By OpenCube"

The File Attributes

Parameter 6
Attribute: Initial File Location
param name = "filelocation"
value="X", where X is the relative location and name of the initial file to load. The file must be specified relative to the document containing the applet. Note: All subsequent applet loading page references must also be defined relative to the document containing the applet.

Parameter 7
Attribute: Use an Overlap Transition when Loading Pages in the Applet
param name = "overlaplocalload"
value=true or false, true = Yes, use an overlap transition effect when loading the next document. false = no first clear the screen then display the next document. A setting of true is only effective if a animation heading was defined within the text file.
DEFAULT: true

The Scroll Bar

Parameter 8
Attribute: Scroll Bar Background Color
param name= "barbgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Black

Parameter 9
Attribute: Scroll Bar Line Increment Value
param name= "barlinejump"
Value=X, Where X is the value to increment in screen pixels when the line increment buttons are pressed (up arrow or down arrow). Note: In Netscape this value also effects how smooth the the applet will scroll when dragging the bubble (page position indicator located between line increment buttons). The page up and page down values are automatically detected (used when the user presses between the bubble and a line increment button).
DEFAULT: 5

Smooth Scrolling

Parameter 10
Attribute: Use Smooth Scrolling
param name= "smoothscrolling"
Value=true or false, true = yes turn smooth scrolling on, false = do not use smooth scrolling. Note: Smooth scrolling creates an animation scroll transition when the scrollbar moves the page to a new position. The relative speed of the transition can be manipulated with the "smoothjump" parameter. When set to false the page simply moves without any special effect to the new position.
DEFAULT: False

Parameter 11
Attribute: Smooth Scrolling Jump Value
param name= "smoothjump"
Value = X, Where X is the distance in screen pixels for each frame of the smooth scrolling animation effect to jump. Note: The lowest possible number, 1, creates the smoothest animation, however takes the longest to transition, the higher the value the faster the effect, hence the choppier the scroll. Watch that this value does not exceed your "barlinejump" parameter value, exceeding this value may cause the page to scroll inappropriately when the line increment buttons are pressed.
DEFAULT: 2

The Window Messages

Parameter 12
Attribute: Default Text Color
param name= "textcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: BLACK

Parameter 13
Attribute: Default Message Font Size
param name="size"
value="X", where X is the default size of all message fonts.
DEFAULT: 14

Parameter 14
Attribute: Default Message Font Name
param name="fontface"
value="X", where X is the name of a standard Java Font (Dialog, Helvetica, TimesRoman, Courier, Symbol)
DEFAULT: "Helvetical"

Parameter 15
Attribute: Default Font Style
param name="style"
value= bold, italic, bolditalic, plain
DEFAULT: plain

Parameter 15
Attribute: Center Text
param name="centertext"
Value = true or false. true = yes center text, false = no left justify text

Parameter 16
Attribute: Left and Right Margin Width
param name="lrmargins"
Value = X, Where X is the width of the right and left margins.

URL Link Properties

Parameter 17
Attribute: Default Load Destination URLs Where?
param name = "loadwhere"
The "loadwhere" tag specifies where the document specified in the "URL" value should be loaded. The default is "_self". A value equal to the name (case sensitive) of a frame will load the document in that frame. Setting this value to applet forces the document to load within the applet itself
"applet" show in the applet
"_self" show in the current frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Note: When targeting a frame location with the name of the frame make certain that the case and names are typed identically. If the applet cannot find the frame the document will be loaded in a new window.

Parameter 18
Attribute: URL Link Highlight Color
param name="hlcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Yellow

Message Window Browser, © 1997, OpenCube Technologies